import os
import subprocess

# 设置路径和参数
DATA_PATH = "./Datasets/evol_instruct_data.json"   # 替换为你的数据路径
OUTPUT_PATH = "./Out/"  # 替换为你的输出路径
MODEL_PATH = './Model/models--deepseek-ai--deepseek-coder-6.7b-instruct/snapshots/e5d64addd26a6a1db0f9b863abf6ee3141936807'  # 使用的模型

# Deepspeed 配置文件路径
DEEPSPEED_CONFIG = "./finetune/configs/ds_config_zero3.json"  # 替换为你自己的配置文件路径

# 设置环境变量（可选，如果你在脚本中设置路径）
#os.environ["DATA_PATH"] = DATA_PATH
#os.environ["OUTPUT_PATH"] = OUTPUT_PATH
#os.environ["CUDA_VISIBLE_DEVICES"] = "0,1"

# 构建 Deepspeed 训练命令
command = [
    "deepspeed", "./finetune/finetune_deepseekcoder.py",  # 训练脚本的路径
    "--model_name_or_path", MODEL_PATH ,
    "--data_path", DATA_PATH,
    "--output_dir", OUTPUT_PATH,
    "--num_train_epochs", "3",
    "--model_max_length", "1024",
    "--per_device_train_batch_size", "16",
    "--per_device_eval_batch_size", "1",
    "--gradient_accumulation_steps", "4",
    "--evaluation_strategy", "no",
    "--save_strategy", "steps",
    "--save_steps", "100",
    "--save_total_limit", "100",
    "--learning_rate", "2e-5",
    "--warmup_steps", "10",
    "--logging_steps", "1",
    "--lr_scheduler_type", "cosine",
    "--gradient_checkpointing", "True",
    "--report_to", "tensorboard",
    "--deepspeed", DEEPSPEED_CONFIG,
    "--bf16", "True"
]

# 执行命令
print("Running the training script with Deepspeed...")
subprocess.run(command)

